/**
 * Created by Kevin Kreps on 09.04.2017.
 *
 * NEWTAB.JS
 *
 *
 * Hope your eyes can handle the mess, mine are bleeding ;)
 *
 */

//__________________________________________CREATE CARDS________________________________________________________________
//chrome.storage.local.remove('cards');
chrome.storage.local.get(function (data) {
    document.getElementById("boxContainerContent").innerHTML = "";
    var contentHolder = document.getElementById("boxContainerContent");
    var cards;
    if (data.cards == undefined) {
        cards = [
            {type: "clock", format24: true, size: 20, frame: "box"},
            {type: "textfield", text: "", height: 8, width: 400, frame: "box"},
            {type: "bookmark", folderID: "1", folderTITLE: "Default", width: 600, frame: "box"}];
    } else {
        cards = data.cards;
        //chrome.storage.local.remove('cards');
    }
    for (var n = 0; n < cards.length; n++) {
        var outputCards = "";
        switch (cards[n].type) {
            case "clock":
                if (cards[n].frame == "box") {
                    outputCards += "<li id='clockBox" + n + "' class='frameBox'>";
                } else if (cards[n].frame == "row") {
                    outputCards += "<li id='clockBox" + n + "' class='frameBox frameCentered'>";
                }
                outputCards += "<div class='simpleBox mdl-color--white mdl-shadow--4dp mdl-color-text--grey-800'>";
                outputCards += "<p id='clockTxt" + n + "' class='clock' style='font-size: " + cards[n].size + "em;'>00:00</p>";
                outputCards += "</div></li>";
                contentHolder.insertAdjacentHTML("beforeend", outputCards);
                refreshTime(n, cards[n].format24);
                break;
            case "bookmark":
                if (cards[n].frame == "box") {
                    outputCards += "<li id='bookmarkBox" + n + "' class='frameBox'>";
                    outputCards += "<div id='bookmarks" + n + "' class='simpleBox mdl-color--white mdl-shadow--4dp mdl-color-text--grey-800' style='overflow: hidden; max-width: " + cards[n].width + "px'></div></li>";
                } else if (cards[n].frame == "row") {
                    outputCards += "<li id='bookmarkBox" + n + "' class='frameBox frameCentered'>";
                    outputCards += "<div id='bookmarks" + n + "' class='simpleBox mdl-color--white mdl-shadow--4dp mdl-color-text--grey-800'></div></li>";
                }
                contentHolder.insertAdjacentHTML("beforeend", outputCards);
                setTheBookmarks(n);
                break;
            case "textfield":
                if (cards[n].frame == "box") {
                    outputCards += "<li id='textfieldBox" + n + "' class='frameBox'>";
                } else if (cards[n].frame == "row") {
                    outputCards += "<li id='textfieldBox" + n + "' class='frameBox frameCentered'>";
                }
                outputCards += "<div class='simpleBox mdl-color--white mdl-shadow--4dp mdl-color-text--grey-800'>";
                outputCards += "<form action='#'>";
                outputCards += "<div class='mdl-textfield mdl-js-textfield' style='width: " + cards[n].width + "px'>";
                outputCards += "<textarea class='mdl-textfield__input' type='text' rows='" + cards[n].height + "' id='textfield_textarea" + n + "'>" + cards[n].text + "</textarea>";
                outputCards += "<label class='mdl-textfield__label' for='sample5'>Notes...</label>";
                outputCards += "</div></form></div></li>";
                contentHolder.insertAdjacentHTML("beforeend", outputCards);
                setTextSavingOnEvent(n);
                break;
            default:
                alert("undefined Card");
                break;
        }

        function setTheBookmarks(n) {
            chrome.bookmarks.getSubTree(cards[n].folderID, function (tree) {
                //console.log(tree);
                configBookmarks(tree[0].children, n);
            });
        }

        //set Listerners for Cards
        document.getElementById(cards[n].type + "Box" + n).addEventListener("click", onclickCard);

        //console.log(outputCards);
    }
    chrome.storage.local.set({'cards': cards});
});


//__________________________________________EDITING_____________________________________________________________________
document.getElementById("toggleEditMode").addEventListener("click", toggleEditMode);
document.getElementById("deleteMode").addEventListener("click", toggledeleteMode);
document.getElementById("rearrangeMode").addEventListener("click", togglerearrangeMode);
document.getElementById("optionsMode").addEventListener("click", toggleoptionsMode);
var availableBookmarkFolders = [];
var editMode = false;
var editType = "rearrange";
var sortable = Sortable.create(document.getElementById('boxContainerContent'), {animation: 150});
sortable.option("disabled", true);
sortable.option("onEnd", function (evt) {
    chrome.storage.local.get(function (data) {
        var dataOfInterest = data.cards[evt.oldIndex];
        data.cards.splice(evt.oldIndex, 1);
        data.cards.splice(evt.newIndex, 0, dataOfInterest);
        chrome.storage.local.set({'cards': data.cards});
    });
});

var dialog = document.getElementById('dialogADD');
var showDialogButton = document.querySelector('#addMode');
if (!dialog.showModal) {
    dialogPolyfill.registerDialog(dialog);
}
showDialogButton.addEventListener('click', function () {
    dialog.showModal();
});
dialog.addEventListener('click', function () {
    setTimeout(function () {
        dialog.close();
    }, 100);
});
dialog.querySelector('#addclock').addEventListener('click', function () {
    addElement({type: "clock", format24: true, size: 20, frame: "box"});
});
dialog.querySelector('#addbookmark').addEventListener('click', function () {
    if (availableBookmarkFolders.length > 0) {
        addElement({
            type: "bookmark", folderID: availableBookmarkFolders[0], folderTITLE: "Default", width: 500, frame: "box"
        });
        availableBookmarkFolders.splice(0, 1);
        //console.log(availableBookmarkFolders);
    } else {
        //chrome.bookmarks.create({parentId: "1", title: "BookmarkCard" + Math.random() * 10});
        alert("NO FOLDERS AVAILABLE, please go to the bookmark manager (chrome://bookmarks/ or use Strg + Shift + O) for further editing options.");
    }
});
dialog.querySelector('#addtextfield').addEventListener('click', function () {
    addElement({type: "textfield", text: "", height: 8, width: 400, frame: "box"});
});
function addElement(item) {
    chrome.storage.local.get(function (data) {
        data.cards.push(item);
        chrome.storage.local.set({'cards': data.cards});
    });
    location.reload();
}

var recentlySelectedCard = 0;
var optionDialogs = [
    document.getElementById('dialogOPTIONSclock'),
    document.getElementById('dialogOPTIONSbookmark'),
    document.getElementById('dialogOPTIONStextfield')
];
if (!optionDialogs[0].showModal) {
    dialogPolyfill.registerDialog(optionDialogs[0]);
}
if (!optionDialogs[1].showModal) {
    dialogPolyfill.registerDialog(optionDialogs[1]);
}
if (!optionDialogs[2].showModal) {
    dialogPolyfill.registerDialog(optionDialogs[2]);
}
optionDialogs[0].querySelector('.cancel').addEventListener('click', function () {
    optionDialogs[0].close();
});
optionDialogs[1].querySelector('.cancel').addEventListener('click', function () {
    optionDialogs[1].close();
});
optionDialogs[2].querySelector('.cancel').addEventListener('click', function () {
    optionDialogs[2].close();
});
optionDialogs[0].querySelector('.save').addEventListener('click', function () {
    chrome.storage.local.get(function (data) {
        if (document.getElementById("clock-list-checkbox-rowmode").checked) {
            data.cards[recentlySelectedCard].frame = "row";
        } else {
            data.cards[recentlySelectedCard].frame = "box";
        }
        data.cards[recentlySelectedCard].format24 = document.getElementById("clock-list-checkbox-format24").checked;
        data.cards[recentlySelectedCard].size = document.getElementById("clock-list-slider-size").value;
        chrome.storage.local.set({'cards': data.cards});
    });
    optionDialogs[0].close();
    location.reload();
});
optionDialogs[1].querySelector('.save').addEventListener('click', function () {
    chrome.storage.local.get(function (data) {
        if (document.getElementById("bookmark-list-checkbox-rowmode").checked) {
            data.cards[recentlySelectedCard].frame = "row";
        } else {
            data.cards[recentlySelectedCard].frame = "box";
        }
        data.cards[recentlySelectedCard].folderID = document.getElementById("bookmark-list-folder-title").folderID;
        data.cards[recentlySelectedCard].folderTITLE = document.getElementById("bookmark-list-folder-title").innerText;
        if (isNumber(document.getElementById("bookmark-list-input-width").value))
            data.cards[recentlySelectedCard].width = document.getElementById("bookmark-list-input-width").value;
        chrome.storage.local.set({'cards': data.cards});
    });
    optionDialogs[1].close();
    location.reload();
});
optionDialogs[2].querySelector('.save').addEventListener('click', function () {
    chrome.storage.local.get(function (data) {
        if (document.getElementById("textfield-list-checkbox-rowmode").checked) {
            data.cards[recentlySelectedCard].frame = "row";
        } else {
            data.cards[recentlySelectedCard].frame = "box";
        }
        if (isNumber(document.getElementById("textfield-list-input-width").value))
            data.cards[recentlySelectedCard].width = document.getElementById("textfield-list-input-width").value;
        if (isNumber(document.getElementById("textfield-list-input-height").value))
            data.cards[recentlySelectedCard].height = document.getElementById("textfield-list-input-height").value;
        chrome.storage.local.set({'cards': data.cards});
    });
    optionDialogs[2].close();
    location.reload();
});
function isNumber(txt) {
    return /^\d+$/.test(txt);
}

function onclickCard(evt) {
    //console.log(evt);
    if (editMode) {
        var id = evt.srcElement.attributes[0].nodeValue;
        recentlySelectedCard = Array.prototype.indexOf.call(document.getElementById('boxContainerContent').children, document.getElementById(id));
        if (editType == "delete") {
            document.getElementById("boxContainerContent").removeChild(document.getElementById(id));
            chrome.storage.local.get(function (data) {
                if (data.cards[recentlySelectedCard].type == "bookmark") {
                    availableBookmarkFolders.push(data.cards[recentlySelectedCard].folderID);
                    console.log(availableBookmarkFolders);
                }
                data.cards.splice(recentlySelectedCard, 1);
                chrome.storage.local.set({'cards': data.cards});
            });
        }
        if (editType == "options") {
            if (id.split("Box")[0] == "clock") {
                chrome.storage.local.get(function (data) {
                    var card = data.cards[recentlySelectedCard];
                    if (card.frame == "box") {
                        document.getElementById("clock-list-checkbox-rowmode").checked = false;
                        document.getElementById("clock-list-checkbox-rowmode").parentNode.classList.remove("is-checked");
                    } else if (card.frame == "row") {
                        document.getElementById("clock-list-checkbox-rowmode").checked = true;
                        document.getElementById("clock-list-checkbox-rowmode").parentNode.classList.add("is-checked");
                    }
                    if (card.format24) {
                        document.getElementById("clock-list-checkbox-format24").checked = true;
                        document.getElementById("clock-list-checkbox-format24").parentNode.classList.add("is-checked");
                    } else {
                        document.getElementById("clock-list-checkbox-format24").checked = false;
                        document.getElementById("clock-list-checkbox-format24").parentNode.classList.remove("is-checked");
                    }
                    document.getElementById("clock-list-slider-size").value = card.size;
                    var ghostEvent = document.createEvent("HTMLEvents");
                    ghostEvent.initEvent('change', true, true);
                    document.getElementById("clock-list-slider-size").dispatchEvent(ghostEvent);
                    optionDialogs[0].showModal();
                });
            } else if (id.split("Box")[0] == "bookmark") {
                chrome.storage.local.get(function (data) {
                    var card = data.cards[recentlySelectedCard];
                    if (card.frame == "box") {
                        document.getElementById("bookmark-list-checkbox-rowmode").checked = false;
                        document.getElementById("bookmark-list-checkbox-rowmode").parentNode.classList.remove("is-checked");
                    } else if (card.frame == "row") {
                        document.getElementById("bookmark-list-checkbox-rowmode").checked = true;
                        document.getElementById("bookmark-list-checkbox-rowmode").parentNode.classList.add("is-checked");
                    }
                    document.getElementById("bookmark-list-folder-title").innerHTML = card.folderTITLE;
                    document.getElementById("bookmark-list-folder-title").folderID = card.folderID;
                    document.getElementById("bookmark-list-input-width").value = card.width;
                    var ghostEvent = document.createEvent("HTMLEvents");
                    ghostEvent.initEvent('input', true, true);
                    document.getElementById("bookmark-list-input-width").dispatchEvent(ghostEvent);
                    optionDialogs[1].showModal();
                });
            } else if (id.split("Box")[0] == "textfield") {
                chrome.storage.local.get(function (data) {
                    var card = data.cards[recentlySelectedCard];
                    if (card.frame == "box") {
                        document.getElementById("textfield-list-checkbox-rowmode").checked = false;
                        document.getElementById("textfield-list-checkbox-rowmode").parentNode.classList.remove("is-checked");
                    } else if (card.frame == "row") {
                        document.getElementById("textfield-list-checkbox-rowmode").checked = true;
                        document.getElementById("textfield-list-checkbox-rowmode").parentNode.classList.add("is-checked");
                    }
                    document.getElementById("textfield-list-input-width").value = card.width;
                    document.getElementById("textfield-list-input-height").value = card.height;
                    var ghostEvent = document.createEvent("HTMLEvents");
                    ghostEvent.initEvent('input', true, true);
                    document.getElementById("textfield-list-input-width").dispatchEvent(ghostEvent);
                    document.getElementById("textfield-list-input-height").dispatchEvent(ghostEvent);
                    optionDialogs[2].showModal();
                });
            }
        }
    }
}

function toggleEditMode() {
    editMode = !editMode;
    var boxes;
    if (editMode) {
        document.getElementById("toggleEditMode").firstElementChild.innerHTML = "close";
        updateButtonColors();
        togglerearrangeMode();
        document.getElementById("deleteMode").style.bottom = "20px";
        document.getElementById("rearrangeMode").style.bottom = "20px";
        document.getElementById("addMode").style.bottom = "20px";
        document.getElementById("optionsMode").style.bottom = "20px";
        boxes = document.getElementsByClassName("simpleBox");
        for (var n2 = 0; n2 < boxes.length; n2++) {
            boxes.item(n2).classList.add("disabledBox");
        }
    } else {
        document.getElementById("toggleEditMode").firstElementChild.innerHTML = "edit";
        document.getElementById("deleteMode").style.bottom = "-70px";
        document.getElementById("rearrangeMode").style.bottom = "-70px";
        document.getElementById("addMode").style.bottom = "-70px";
        document.getElementById("optionsMode").style.bottom = "-70px";
        updateButtonColors();
        sortable.option("disabled", true);
        boxes = document.getElementsByClassName("simpleBox");
        for (var n1 = 0; n1 < boxes.length; n1++) {
            boxes.item(n1).classList.remove("disabledBox");
        }
    }
}

function toggledeleteMode() {
    editType = "delete";
    updateButtonColors();
}
function togglerearrangeMode() {
    editType = "rearrange";
    sortable.option("disabled", false);
    updateButtonColors();
}
function toggleoptionsMode() {
    editType = "options";
    updateButtonColors();
}

function updateButtonColors() {
    document.getElementById("deleteMode").classList.remove("mdl-button--colored");
    document.getElementById("rearrangeMode").classList.remove("mdl-button--colored");
    document.getElementById("optionsMode").classList.remove("mdl-button--colored");
    document.getElementById(editType + "Mode").classList.add("mdl-button--colored");
}

//__________________________________________MODULES_____________________________________________________________________
//-------------------------------------------clock----------------------------------------------------------------------
function refreshTime(id, format24) {
    var d = new Date();
    var h = d.getHours();
    var m = d.getMinutes();
    if (!format24) {
        if (h > 12) {
            h -= 12;
        }
    }
    if (h < 10) {
        h = "0" + h;
    }
    if (m < 10) {
        m = "0" + m;
    }
    if (document.getElementById("clockTxt" + id)) {
        document.getElementById("clockTxt" + id).innerHTML = h + ":" + m;
        setTimeout(function () {
            refreshTime(id, format24);
        }, 1000);
    }
}
//-------------------------------------------textfield------------------------------------------------------------------
function setTextSavingOnEvent(id) {
    var textareaChanged = function () {
        chrome.storage.local.get(function (data) {
            data.cards[Array.prototype.indexOf.call(document.getElementById('boxContainerContent').children, document.getElementById("textfieldBox" + id))].text = document.getElementById("textfield_textarea" + id).value;
            chrome.storage.local.set({'cards': data.cards});
        });
    };
    document.getElementById("textfield_textarea" + id).addEventListener('change', textareaChanged);
    document.getElementById("textfield_textarea" + id).addEventListener('keyup', textareaChanged);
}
//-------------------------------------------bookmarks------------------------------------------------------------------
var highQualityBookmarks = [];
function configBookmarks(bookmarksData, id) {
    chrome.storage.local.get(function (data) {
        var bookmarkIconLinks = data.bookmarkIconLinks;
        //console.log(bookmarksData);
        var bookmarkContent = "";
        for (var i = 0, len = bookmarksData.length; i < len; i++) {
            if (typeof bookmarksData[i].children === 'undefined') {
                var chip = "";
                chip += "<a id='TheBookmark" + bookmarksData[i].id + "' class='mdl-chip mdl-chip--contact mdl-js-ripple-effect mdl-button mdl-js-button' href='" + bookmarksData[i].url + "' style='text-align: left; padding: 0; min-width: 0; margin: 2px;'>";
                var picLink = undefined;
                for (var i2 = 0; i2 < bookmarkIconLinks.length; i2++) {
                    if (bookmarksData[i].url == bookmarkIconLinks[i2][0]) {
                        picLink = bookmarkIconLinks[i2][1];
                    }
                }
                chip += "<img id='BookmarkImage" + id + bookmarksData[i].id + "' class='mdl-chip__contact' style='margin: 0; padding: 8px; width: 16px; height: 16px; transition: all .1s ease-in-out' src='" + "chrome://favicon/" + bookmarksData[i].url + "'>";
                if (picLink != undefined) {
                    highQualityBookmarks.push([id + bookmarksData[i].id, picLink]);
                }
                if (bookmarksData[i].title != "") {
                    chip += "<span class='mdl-chip__text' style='padding: 0 12px 0 8px; font-weight: 400; text-transform: none;'>";
                    chip += bookmarksData[i].title;
                    chip += "</span>";
                }
                chip += "</a>";
                bookmarkContent += chip;
            }
        }
        document.getElementById("bookmarks" + id).innerHTML = bookmarkContent;
        document.getElementById("bookmarks" + id).addEventListener('contextmenu', function (evt) {
            console.log(evt);
            var clickedNode = evt.srcElement;
            var continueSearch = true;
            while (continueSearch) {
                if (clickedNode.id.slice(0, 11) == "TheBookmark") {
                    continueSearch = false;
                    document.getElementById("bookmarkRightClickOption").style.left = evt.pageX + "px";
                    document.getElementById("bookmarkRightClickOption").style.top = (evt.pageY + document.getElementById("boxContainer").scrollTop) + "px";
                    document.getElementById("deleteBookmarkChip").bookmarkID = clickedNode.id.slice(11);
                    document.getElementById("editBookmarkChip").bookmarkID = clickedNode.id.slice(11);
                    var ghostEvent = document.createEvent("HTMLEvents");
                    ghostEvent.initEvent('click', true, true);
                    document.getElementById("bookmarkRightClickOption").dispatchEvent(ghostEvent);
                } else if (clickedNode.id.slice(0, 9) == "bookmarks") {
                    continueSearch = false;
                } else {
                    clickedNode = clickedNode.parentNode;
                }
            }
            evt.preventDefault();
        }, false);
        var bookmarkSortable = Sortable.create(document.getElementById("bookmarks" + id), {
            group: "bookmarks", animation: 150, scrollSensitivity: 100, scrollSpeed: 15
        });
        bookmarkSortable.option("setData", function (dataTransfer) {
            dataTransfer.setDragImage(document.createElement("img"), 0, 0);
        });
        bookmarkSortable.option("onEnd", function (evt) {
            console.log("ID-old " + evt.oldIndex);
            console.log("ID-new " + evt.newIndex);
            //console.log("CardOrig " + id);
            chrome.storage.local.get(function (data) {
                var cards = data.cards;
                //var nCardTargetStatic = parseInt(evt.item.parentNode.attributes.id.value.slice(9));
                var nCardTargetID = Array.prototype.indexOf.call(evt.item.parentNode.parentNode.parentNode.children, evt.item.parentNode.parentNode);
                var folderIDOrigin = cards[Array.prototype.indexOf.call(document.getElementById("boxContainerContent").children, document.getElementById("bookmarkBox" + id))].folderID;
                var folderIDTarget = cards[nCardTargetID].folderID;
                chrome.bookmarks.getSubTree(folderIDOrigin, function (treeOrigin) {
                    chrome.bookmarks.getSubTree(folderIDTarget, function (treeTarget) {
                        treeOrigin = treeOrigin[0].children;
                        console.log(treeOrigin);
                        for (var bookmarkNode = treeOrigin.length; bookmarkNode > 0; bookmarkNode--) {
                            //console.log(tree[bookmarkNode]);
                            if (treeOrigin[bookmarkNode - 1].children) {
                                treeOrigin.splice(bookmarkNode - 1, 1);
                                console.log("spliced");
                            }
                        }
                        var bookmarkNewIndex = evt.newIndex;
                        var treeTargetBookmarkCount = 0;
                        treeTarget = treeTarget[0].children;
                        for (var treeTargetId = 0; treeTargetId < treeTarget.length && treeTargetBookmarkCount <= evt.newIndex; treeTargetId++) {
                            if (treeTarget[treeTargetId].children) {
                                bookmarkNewIndex++;
                            } else {
                                treeTargetBookmarkCount++;
                            }
                        }
                        chrome.bookmarks.move(treeOrigin[evt.oldIndex].id, {
                            parentId: folderIDTarget,
                            index: (evt.newIndex > evt.oldIndex && folderIDOrigin == folderIDTarget) ? bookmarkNewIndex + 1 : bookmarkNewIndex
                        }, function callback() {
                            console.log("went Fine: " + folderIDOrigin + " " + folderIDTarget);
                        });
                    });
                });
                chrome.storage.local.set({'cards': cards});
            });
        });
        //console.log(highQualityBookmarks);
        setHigherFaviconQuality(highQualityBookmarks);
    });
}
function setHigherFaviconQuality(data) {
    window.onload = function () {
        //console.log("loaded");
        //console.log(data);
        var img = [];
        for (var i = 0; i < data.length; i++) {
            img.push(new Image());
            img[i].src = data[i][1];
            var imgOnload = function (data, i) {
                img[i].onload = function () {
                    if (this.naturalWidth > 20) {
                        document.getElementById("BookmarkImage" + data[i][0]).style.padding = "0";
                        document.getElementById("BookmarkImage" + data[i][0]).style.width = "32px";
                        document.getElementById("BookmarkImage" + data[i][0]).style.height = "32px";
                    }
                    document.getElementById("BookmarkImage" + data[i][0]).src = data[i][1];
                };
            };
            imgOnload(data, i);
        }
    };
}
/**
 * generate tree of bookmarcs in chrome storage for better favicon links
 * also, put all the bookmark folders into the options menu
 */
chrome.bookmarks.getTree(function (tree) {
    var bookmarksData = tree[0].children;
    chrome.storage.local.get(function (data) {
        var bookmarkIconLinks = data.bookmarkIconLinks;
        if (typeof bookmarkIconLinks === 'undefined') {
            bookmarkIconLinks = [];
        }
        //bookmarkIconLinks = []; //todo what happens when there is no data in the beginning
        var optionsMenu = document.getElementById("bookmark-list-folder");

        checkFolder(bookmarksData);
        function checkFolder(folder) {
            for (var i = 0; i < folder.length; i++) {
                if (typeof folder[i].children === 'undefined') { //is no folder
                    var found = false;
                    for (var j = 0; j < bookmarkIconLinks.length; j++) {
                        if (folder[i].url == bookmarkIconLinks[j][0]) {
                            found = true;
                        }
                    }
                    if (!found) {
                        bookmarkIconLinks.push([folder[i].url, undefined]);
                    }
                } else { //is a folder
                    //console.log(folder[i]);
                    var menuItem = "<li ";
                    var alreadyInCards = false;
                    for (var cardId = 0; cardId < data.cards.length; cardId++) {
                        if (data.cards[cardId].type == "bookmark") {
                            if (data.cards[cardId].folderID == folder[i].id) {
                                alreadyInCards = true;
                            }
                        }
                    }
                    if (alreadyInCards) {
                        menuItem += "disabled ";
                    }
                    menuItem += "class='mdl-menu__item'>" + folder[i].title + "</li>";
                    document.getElementById("bookmark-list-folder-selector").insertAdjacentHTML("beforeend", menuItem);
                    var addevtListerners = function (i) {
                        document.getElementById("bookmark-list-folder-selector").lastChild.addEventListener('click', function () {
                            //console.log(folder[i].title);
                            document.getElementById("bookmark-list-folder-title").innerHTML = folder[i].title;
                            document.getElementById("bookmark-list-folder-title").folderID = folder[i].id;
                        });
                    };
                    if (!alreadyInCards) {
                        availableBookmarkFolders.push(folder[i].id);
                        //console.log(availableBookmarkFolders);
                        addevtListerners(i);
                    }
                    checkFolder(folder[i].children);
                }
            }
        }

        //todo remove unused Links from bookmarkIconLinks
        chrome.storage.local.set({'bookmarkIconLinks': bookmarkIconLinks});
        //console.log(bookmarkIconLinks);
    });
});
/**
 * Onclick listerners for the Right-Click-Menu items on the bookmarks
 */
document.getElementById("deleteBookmarkChip").addEventListener("click", function () {
    document.getElementById("TheBookmark" + document.getElementById("deleteBookmarkChip").bookmarkID).parentElement.removeChild(document.getElementById("TheBookmark" + document.getElementById("deleteBookmarkChip").bookmarkID));
    chrome.bookmarks.remove(document.getElementById("deleteBookmarkChip").bookmarkID);
});
document.getElementById("editBookmarkChip").addEventListener("click", function () {
    var dialogBookmarkChipEdit = document.getElementById('dialogEditBookmarkChip');
    if (!dialogBookmarkChipEdit.showModal) {
        dialogPolyfill.registerDialog(dialogBookmarkChipEdit);
    }
    chrome.bookmarks.get(document.getElementById("editBookmarkChip").bookmarkID, function (bookmark) {
        document.getElementById("EditBookmarkChipURL").value = bookmark[0].url;
        document.getElementById("EditBookmarkChipName").value = bookmark[0].title;
        var ghostEvent = document.createEvent("HTMLEvents");
        ghostEvent.initEvent('input', true, true);
        document.getElementById("EditBookmarkChipURL").dispatchEvent(ghostEvent);
        document.getElementById("EditBookmarkChipName").dispatchEvent(ghostEvent);
    });
    dialogBookmarkChipEdit.showModal();
    dialogBookmarkChipEdit.querySelector(".cancel").addEventListener('click', function () {
        dialogBookmarkChipEdit.close();
    });
    dialogBookmarkChipEdit.querySelector(".save").addEventListener('click', function () {
        chrome.bookmarks.update(document.getElementById("editBookmarkChip").bookmarkID, {
            title: document.getElementById("EditBookmarkChipName").value,
            url: document.getElementById("EditBookmarkChipURL").value
        });
        dialogBookmarkChipEdit.close();
        location.reload();
    });
});


/**
 * Loading the material.js/material.min.js file at the end when every component is properly set
 * due to issues with the Ripple-Effect
 * */
function loadjscssfile(filename) {
    var fileref = document.createElement('script');
    fileref.setAttribute("type", "text/javascript");
    fileref.setAttribute("src", filename);
    if (typeof fileref != "undefined")
        document.getElementsByTagName("head")[0].appendChild(fileref);
}
loadjscssfile("material.min.js");

//console.log("loading");